//===========================================================================
// main.cpp
// 2D-Linien zeichnen mit OpenGL
//===========================================================================

//===========================================================================
// includes
//===========================================================================

#include "spiral.h"

/* GL und GLUT Bibliotheken einbinden (je nach Betriebssystem) */

#ifdef WIN32
    #include <windows.h>
    #include <GL/gl.h>
    #include <GL/glut.h>
#else
    #include <GL/gl.h>
    #include <GLUT/glut.h>
#endif


//===========================================================================
// globale Variablen
//===========================================================================

CSpiral spiral;


//===========================================================================
// implementierung
//===========================================================================

void display(void)
{
    // Hintergrundfarbe (rgba) setzen
    glClearColor(0.0, 0.0, 0.0, 1.0);

    // Hintergrund lschen
    glClear(GL_COLOR_BUFFER_BIT);

    // orthogonale Projektion setzen (2D)
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    glOrtho(-1, 1,  // X Achsen Koordinaten von..bis
            -1, 1,  // Y Achsen Koordinaten von..bis
            -1, 1); // Z Achsen Koordinaten von..bis

    // Farbe setzen
    glColor3f(1.0f, 1.0f, 1.0f);

    // Spirale in hinteren Bildschirmpuffer zeichnen
    spiral.render();
    
    // Hinteren Bildschirmpuffer nach vorne bringen
    glutSwapBuffers();

    // Spirale einen Animationsschritt weiter rotieren
    // (Rotationszeit bei 60Hz Wiederholrate = 1/4 Sekunde)
    spiral.rotate(360.0f / 60.0f * 4.0f);

    // Erneutes Zeichnen veranlassen, damit sich eine Animation ergibt
    glutPostRedisplay();
}


int main(int argc, char* argv[])
{
    // GLUT mit Kommandozeilenparametern initialisieren
    glutInit(&argc, argv);

    // RGB-Modus mit Hintergrundpuffer whlen
    glutInitDisplayMode(GLUT_RGB | GLUT_DOUBLE);

    // Fenster erzeugen
    glutCreateWindow("Spirale");

    // unsere eigene Anzeigefunktion setzen
    glutDisplayFunc(display);

    // Hauptschleife des Programms aufrufen
    glutMainLoop();

    // Alles ok, Programm beenden
    return 0;
}
